#include "LibGenerator/PrecompiledHeader.h"

#include "LibGenerator/Pixel.h"

#ifdef __WXMSW__
#	include<wx/msw/msvcrt.h>
#endif

using namespace ProceduralTextures;

//*************************************************************************************************

UbPixel ProceduralTextures :: Substract( const UbPixel & p_a, const UiPixel & p_b, const UbPixel & p_min)
{
	UbPixel l_result;

	if (p_a.r >= p_min.r + p_b.r)
	{
		l_result.r = p_a.r - p_b.r;
	}
	else
	{
		l_result.r = p_min.r;
	}

	if (p_a.g >= p_min.g + p_b.g)
	{
		l_result.g = p_a.g - p_b.g;
	}
	else
	{
		l_result.g = p_min.g;
	}

	if (p_a.b >= p_min.b + p_b.b)
	{
		l_result.b = p_a.b - p_b.b;
	}
	else
	{
		l_result.b = p_min.b;
	}

	if (p_a.a >= p_min.a + p_b.a)
	{
		l_result.a = p_a.a - p_b.a;
	}
	else
	{
		l_result.a = p_min.a;
	}

	return l_result;
}

UbPixel ProceduralTextures :: Add( const UbPixel & p_a, const UiPixel & p_b, const UbPixel & p_max)
{
	UbPixel l_result;

	if (p_a.r + p_b.r < p_max.r)
	{
		l_result.r = p_a.r + p_b.r;
	}
	else
	{
		l_result.r = p_max.r;
	}

	if (p_a.g + p_b.g < p_max.g)
	{
		l_result.g = p_a.g + p_b.g;
	}
	else
	{
		l_result.g = p_max.g;
	}

	if (p_a.b + p_b.b < p_max.b)
	{
		l_result.b = p_a.b + p_b.b;
	}
	else
	{
		l_result.b = p_max.b;
	}

	if (p_a.a + p_b.a < p_max.a)
	{
		l_result.a = p_a.a + p_b.a;
	}
	else
	{
		l_result.a = p_max.a;
	}

	return l_result;
}

UbPixel ProceduralTextures :: Substract( const UiPixel & p_a, const UiPixel & p_b, const UbPixel & p_min)
{
	UbPixel l_result;

	if (p_a.r >= p_min.r + p_b.r)
	{
		l_result.r = p_a.r - p_b.r;
	}
	else
	{
		l_result.r = p_min.r;
	}

	if (p_a.g >= p_min.g + p_b.g)
	{
		l_result.g = p_a.g - p_b.g;
	}
	else
	{
		l_result.g = p_min.g;
	}

	if (p_a.b >= p_min.b + p_b.b)
	{
		l_result.b = p_a.b - p_b.b;
	}
	else
	{
		l_result.b = p_min.b;
	}

	if (p_a.a >= p_min.a + p_b.a)
	{
		l_result.a = p_a.a - p_b.a;
	}
	else
	{
		l_result.a = p_min.a;
	}

	return l_result;
}

UbPixel ProceduralTextures :: Add( const UiPixel & p_a, const UiPixel & p_b, const UbPixel & p_max)
{
	UbPixel l_result;

	if (p_a.r + p_b.r < p_max.r)
	{
		l_result.r = p_a.r + p_b.r;
	}
	else
	{
		l_result.r = p_max.r;
	}

	if (p_a.g + p_b.g < p_max.g)
	{
		l_result.g = p_a.g + p_b.g;
	}
	else
	{
		l_result.g = p_max.g;
	}

	if (p_a.b + p_b.b < p_max.b)
	{
		l_result.b = p_a.b + p_b.b;
	}
	else
	{
		l_result.b = p_max.b;
	}

	if (p_a.a + p_b.a < p_max.a)
	{
		l_result.a = p_a.a + p_b.a;
	}
	else
	{
		l_result.a = p_max.a;
	}

	return l_result;
}

//*************************************************************************************************