#include "LibGenerator/PrecompiledHeader.h"

#include "LibGenerator/StatusUpdateEvent.h"

#ifdef __WXMSW__
#	include<wx/msw/msvcrt.h>
#endif

using namespace ProceduralTextures;

//*************************************************************************************************

DEFINE_EVENT_TYPE( ProceduralTextures::wxEVT_STATUS_UPDATE)
IMPLEMENT_DYNAMIC_CLASS( wxStatusUpdateEvent, wxNotifyEvent)

wxStatusUpdateEvent :: wxStatusUpdateEvent( int p_iIndex, int p_winid)
	:	wxNotifyEvent( wxEVT_STATUS_UPDATE)
	,	m_time( 0)
	,	m_savedTime( wxGetLocalTimeMillis())
	,	m_iIndex( p_iIndex)
{
}
wxStatusUpdateEvent :: wxStatusUpdateEvent( const wxStatusUpdateEvent & p_event)
	:	wxNotifyEvent( p_event)
	,	m_time( p_event.m_time)
	,	m_savedTime( p_event.m_savedTime)
	,	m_iIndex( p_event.m_iIndex)
{
}

void wxStatusUpdateEvent :: ResetTime()
{
	m_time = wxGetLocalTimeMillis() - m_savedTime;
	m_savedTime = wxGetLocalTimeMillis();
}

wxEvent * wxStatusUpdateEvent :: Clone() const
{
	return new wxStatusUpdateEvent( * this);
}

//*************************************************************************************************

#if defined( _WIN32) && wxVERSION_NUMBER < 2900
DEFINE_EVENT_TYPE( ProceduralTextures::wxEVT_THREAD)
IMPLEMENT_DYNAMIC_CLASS( wxThreadEvent, wxEvent)

wxThreadEvent :: wxThreadEvent( wxEventType p_eventType, int p_id)
	:	wxEvent( p_id, p_eventType)
{
}

wxThreadEvent :: wxThreadEvent( const wxThreadEvent & p_event)
	:	wxEvent( p_event)
{
	SetString( GetString().c_str());
}

wxEvent * wxThreadEvent :: Clone()const
{
	return new wxThreadEvent( * this);
}
#endif

//*************************************************************************************************